#define BUSY 4
#define RESET 5
#define LED0 10
#define LED1 11

String inputString = "";         // a string to hold incoming data
String bufString = "";

int led_ctrl0=0, led_ctrl1=0;
int cnt_led0=0, cnt_led1=0;
int brightness[]={ 0, 1, 2, 4, 8, 16, 32, 64, 128, 255, 128, 64, 32, 16, 8, 4, 2, 1, 0 };

void setup() {
  pinMode(BUSY, INPUT);
  pinMode(RESET, OUTPUT);
  pinMode(LED0, OUTPUT);
  pinMode(LED1, OUTPUT);
  digitalWrite(RESET, LOW);
  digitalWrite(LED0, LOW);
  digitalWrite(LED1, LOW);

  Serial.begin(19200);
  inputString.reserve(100);
  bufString.reserve(10);
  
  delay(10);
  digitalWrite(RESET, HIGH);
  delay(100);
}

void loop() {
  if (Serial.available() > 0) {
    char inChar = Serial.read();
    inputString += inChar;
    if (inChar == '\n') {
      CMD_GET();
      inputString = "";
      bufString = "";
    }
  }  /*  */

  if (led_ctrl0==0) {
    digitalWrite(LED0, LOW);
    cnt_led0 = 0;
  } else if (led_ctrl0==1) {
    digitalWrite(LED0, (cnt_led0 < 5) );
    cnt_led0++;
    if ( cnt_led0 > 9 ) {
      cnt_led0 = 0;
    }
  } else if (led_ctrl0==2) {
    analogWrite(LED0, brightness[cnt_led0]);
    cnt_led0++;
    if ( cnt_led0 > 18 ) {
      cnt_led0 = 0;
    }
  }

  if (led_ctrl1==0) {
    digitalWrite(LED1, LOW);
    cnt_led1 = 0;
  } else if (led_ctrl1==1) {
    digitalWrite(LED1, (cnt_led1 < 5) );
    cnt_led1++;
    if ( cnt_led1 > 9 ) {
      cnt_led1 = 0;
    }
  } else if (led_ctrl1==2) {
    analogWrite(LED1, brightness[cnt_led1]);
    cnt_led1++;
    if ( cnt_led1 > 18 ) {
      cnt_led1 = 0;
    }
  }

  delay(100);
}

void CMD_GET(void) {
  int dataindex;
  char **e;
  
  dataindex = inputString.indexOf(':') + 1;
  bufString = inputString.substring(dataindex, (dataindex + 2));
  const char *s = bufString.c_str();
  int cmd = (int)strtol(s, e, 10);

  switch( cmd ) {
    case 0:
      led_ctrl0 = 0;
      break;
    case 1:
      led_ctrl0 = 1;
      break;
    case 2:
      led_ctrl0 = 2;
      break;
    case 10:
      led_ctrl1 = 0;
      break;
    case 11:
      led_ctrl1 = 1;
      break;
    case 12:
      led_ctrl1 = 2;
      break;
    default:
      led_ctrl0 = 0;
      led_ctrl1 = 0;    
  }
}

